'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.astNodeVisitor = undefined;

var _syntax = require('jsdoc/src/syntax');

var _astnode = require('jsdoc/src/astnode');

/**
 * A jsdoc plugin for detecting the use of a commonjs
 * interop in default exports from es6 module export syntax.
 *
 * @module jsdoc-export-default-interop
 */

/**
 * The plugin object.
 *
 * @see http://usejsdoc.org/about-plugins.html
 * @type {Object}
 */
var astNodeVisitor = exports.astNodeVisitor = {
  visitNode: function visitNode(node, e) {
    if (node.type === _syntax.Syntax.ExportDefaultDeclaration) {
      setNodeToNamed.call(e);
    }
  }
};

function setNodeToNamed() {
  var name = arguments.length <= 0 || arguments[0] === undefined ? 'default' : arguments[0];

  this.astnode.type = _syntax.Syntax.ExportNamedDeclaration;
  this.code = (0, _astnode.getInfo)(this.astnode);
  this.code.name = 'exports.' + name;
}